"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// tslint:disable no-require-imports member-ordering
const _sg = require("strong-globalize");
const sqlite3_connector_1 = require("./sqlite3-connector");
const sqlite3orm_1 = require("sqlite3orm");
// tslint:disable-next-line no-unused-variable
const g = new _sg();
/* istanbul ignore next */ // tslint:disable-next-line no-unused-variable
function debug(arg, ...args) {
    sqlite3_connector_1.Sqlite3Connector.debug(arg, ...args);
}
// sample implementation for MySql:
// https://github.com/strongloop/loopback4-example-microservices/blob/master/services/account-without-juggler/repositories/account/datasources/mysqlconn.ts
/* istanbul ignore next */
class Sqlite3CrudConnector extends sqlite3_connector_1.Sqlite3Connector /* implements
    CrudConnector */ {
    constructor(settings) {
        super(settings);
    }
    classToMetaModel(modelClass) {
        let metaModel = Reflect.getMetadata(sqlite3orm_1.METADATA_MODEL_KEY, modelClass.prototype);
        if (!metaModel) {
            metaModel =
                super.getMetaModel(modelClass.modelName, modelClass.definition);
        }
        return metaModel;
    }
    /*************************************************************************************
     * CrudConnector interface
     */
    /**
     * Create a new entity
     * @param modelClass The model class
     * @param entity The entity instance or data
     * @param options Options for the operation
     * @returns A promise of the entity created
     */
    create(modelClass, entity, options) {
        throw new Error('TODO: Not implemented yet.');
    }
    /**
     * Create multiple entities
     * @param modelClass The model class
     * @param entities An array of entity instances or data
     * @param options Options for the operation
     * @returns A promise of an array of entities created
     */
    createAll(modelClass, entities, options) {
        throw new Error('TODO: Not implemented yet.');
    }
    /**
     * Save an entity
     * @param modelClass The model class
     * @param entity The entity instance or data
     * @param options Options for the operation
     * @returns A promise of the entity saved
     */
    save(modelClass, entity, options) {
        throw new Error('TODO: Not implemented yet.');
    }
    /**
     * Find matching entities by the filter
     * @param modelClass The model class
     * @param filter The query filter
     * @param options Options for the operation
     * @returns A promise of an array of entities found for the filter
     */
    find(modelClass, filter, options) {
        throw new Error('TODO: Not implemented yet.');
    }
    /**
     * Find an entity by id
     * @param modelClass The model class
     * @param id The entity id value
     * @param options Options for the operation
     * @returns A promise of the entity found for the id
     */
    findById(modelClass, id, options) {
        throw new Error('TODO: Not implemented yet.');
    }
    /**
     * Update an entity
     * @param modelClass The model class
     * @param entity The entity instance or data
     * @param options Options for the operation
     * @returns Promise<true> if an entity is updated, otherwise
     * Promise<false>
     */
    update(modelClass, entity, options) {
        throw new Error('TODO: Not implemented yet.');
    }
    /**
     * Delete an entity
     * @param modelClass The model class
     * @param entity The entity instance or data
     * @param options Options for the operation
     * @returns Promise<true> if an entity is deleted, otherwise
     * Promise<false>
     */
    delete(modelClass, entity, options) {
        throw new Error('TODO: Not implemented yet.');
    }
    /**
     * Update matching entities
     * @param modelClass The model class
     * @param data The data attributes to be updated
     * @param where The matching criteria
     * @param options Options for the operation
     * @returns A promise of number of matching entities deleted
     */
    updateAll(modelClass, data, where, options) {
        throw new Error('TODO: Not implemented yet.');
    }
    /**
     * Update an entity by id
     * @param modelClass The model class
     * @param id The entity id value
     * @param data The data attributes to be updated
     * @param options Options for the operation
     * @returns Promise<true> if an entity is updated for the id, otherwise
     * Promise<false>
     */
    updateById(modelClass, id, data, options) {
        throw new Error('TODO: Not implemented yet.');
    }
    /**
     * Replace an entity by id
     * @param modelClass The model class
     * @param id The entity id value
     * @param data The data attributes to be updated
     * @param options Options for the operation
     * @returns Promise<true> if an entity is replaced for the id, otherwise
     * Promise<false>
     */
    replaceById(modelClass, id, data, options) {
        throw new Error('TODO: Not implemented yet.');
    }
    /**
     * Delete matching entities
     * @param modelClass The model class
     * @param where The matching criteria
     * @param options Options for the operation
     * @returns A promise of number of matching entities deleted
     */
    deleteAll(modelClass, where, options) {
        throw new Error('TODO: Not implemented yet.');
    }
    /**
     * Delete an entity by id
     * @param modelClass The model class
     * @param id The entity id value
     * @param options Options for the operation
     * @returns Promise<true> if an entity is deleted for the id, otherwise
     * Promise<false>
     */
    deleteById(modelClass, id, options) {
        throw new Error('TODO: Not implemented yet.');
    }
    /**
     * Count matching entities
     * @param modelClass The model class
     * @param where The matching criteria
     * @param options Options for the operation
     * @returns A promise of number of matching entities
     */
    count(modelClass, where, options) {
        throw new Error('TODO: Not implemented yet.');
    }
    /**
     * Check if an entity exists for the id
     * @param modelClass The model class
     * @param id The entity id value
     * @param options Options for the operation
     * @returns Promise<true> if an entity exists for the id, otherwise
     * Promise<false>
     */
    exists(modelClass, id, options) {
        throw new Error('TODO: Not implemented yet.');
    }
}
exports.Sqlite3CrudConnector = Sqlite3CrudConnector;
//# sourceMappingURL=sqlite3-crud-connector.js.map